#include <stdio.h>
#include <stdlib.h>

typedef struct node {
	int n;
	struct node * next;
} Node;

Node * reverse_iter(Node * prev, Node* curr)
{
	Node * tmp;

	if (curr == NULL)
		return prev;
	// keep a link to the next node
	tmp = curr->next;
	// change direction
	curr->next = prev;
	// reverse the the rest of the list
	return reverse_iter(curr, tmp);
}

Node * reverse(Node * head)
{	
	return reverse_iter(NULL, head);
}



void printList(Node * head)
{
	while (head != NULL)
	{
		printf("%d ", head->n);
		head = head->next;
	}
	printf("\n");
}

Node * initNode(int n)
{
	Node * newNode = (Node *)malloc(sizeof(Node));
	newNode->n = n;
	newNode->next = NULL;
	return newNode;
}

Node * addLast(Node * head, Node * newNode)
{
	Node * tmp = head; 

	if (head == NULL)
		return newNode;
	// find the last node
	while (tmp->next != NULL)
		tmp = tmp->next;
	
	tmp->next = newNode;
	return head;
}

int main()
{
	Node * head = NULL;
	int i, n;

	printf("insert 10 numbers\n");	
	for (i = 0; i < 10; ++i)
	{		
		scanf("%d", &n);
		head = addLast(head, initNode(n));
	}
	
	head = reverse(head);
	printf("After reverse:\n");
	printList(head);	

	return 0;
}
