#include <stdlib.h>
#include <stdio.h>

typedef struct element
{
	int data;
	struct element *next;
} Element; 

typedef struct stack_t
{
    int size;
    Element *head;
} Stack;



Stack * createStack()
{
    Stack *s = (Stack*) malloc(sizeof(Stack));
    if (s != NULL)
    {
        s->size = 0;
        s->head = NULL;
    }
    return s;
}

Element * createElement(int data)
{
    Element *e = (Element*) malloc(sizeof(Element));
    if (e != NULL)
    {
        e->data = data;
        e->next = NULL;
    }
    return e;
}

void push(Stack *s, int data)
{
    Element *e = createElement(data);
    if (e == NULL)
    {
        printf("Fatal error: unable to allocate memory!\n");
        exit(1);
    }
    e->next = s->head;
    s->head = e;
    s->size++;
}

int pop(Stack *s) // assume s is not empty
{
	Element *first = s->head;
	int data = first->data;
	
	s->head = s->head->next;
	s->size--;
	
	free(first);
	return data;
}

int isEmpty(Stack *s)
{
    return s->size == 0;
}


int stackSum(Stack *s)
{
	int sum = 0;

	while (!isEmpty(s))
		sum += pop(s);

	return sum;
}

int main()
{
	int val;
	Stack *s = createStack();
	if (s == NULL) {
		printf("unable to create stack!");
		return 1;
	}
	printf("Please enter input\n");
	scanf("%d", &val);
	while (val >= 0) {
		push(s, val);
		scanf("%d", &val);
	}
	printf("The sum is %d\n", stackSum(s));
	
	free(s);
	return 0;
}


